<template>
	<v-container class="Groups" :class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
		<v-skeleton-loader v-if="groupsAreLoading" type="card" min-height="500px" />
		<div v-else-if="groupsHaveError" rounded="lg">Error loading groups. Please refresh.</div>
		<div v-else-if="groupsAreLoaded">
			<v-container class="d-flex justify-end align-end">
				<v-btn class="primary my-auto d-inline-block" rounded @click="addGroup">Add group</v-btn>
			</v-container>
			<v-card class="pb-2 mt-5" rounded="lg">
				<v-card-text>
					<v-list>
						<group-list-row v-for="group in rootGroups" :key="group.id" :group="group" />
						<v-list-item v-if="rootGroups.length === 0">
							<v-list-item-content class="pb-1">
								<v-list-item-subtitle> You are not a member of any group, yet. </v-list-item-subtitle>
							</v-list-item-content>
						</v-list-item>
					</v-list>
				</v-card-text>
			</v-card>
		</div>
	</v-container>
</template>

<script lang="ts">
import { computed, defineComponent } from '@vue/composition-api';
import { useGroups } from '@/store/modules/group';
import { Group } from '@/store/types';
import GroupListRow from '@/views/group/GroupListRow.vue';

export default defineComponent({
	components: {
		GroupListRow,
	},
	setup(_, { root }) {
		const { isLoading: groupsAreLoading, isLoaded: groupsAreLoaded, hasError: groupsHaveError, groupTree } = useGroups(
			root.$store
		);

		const rootGroups = computed<Group[]>(() => groupTree.value.filter((group) => group.level === 1));

		const addGroup = () => {
			root.$router.push(`/groups/new`);
		};

		return {
			rootGroups,
			addGroup,
			groupsAreLoaded,
			groupsHaveError,
			groupsAreLoading,
		};
	},
});
</script>

<style lang="scss"></style>
